Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.jini.export
Interface Exporter

All Known Implementing Classes:
  ActivationExporter, BasicJeriExporter, IiopExporter, InstantiatorAccessExporter, JrmpExporter, MonitorAccessExporter, ProxyTrustExporter, SunJrmpExporter, SystemAccessExporter

public interface Exporter

An abstraction for exporting a single remote object such that it can receive remote method invocations, and later for unexporting that same remote object.

Details of the export and unexport behavior, including the communication protocols used for remote invocation and additional remote invocation semantics, are defined by the particular implementation of this interface.

Since:
  2.0

Method Summary
`Remote` | `export(Remote impl)` Exports the specified remote object and returns a proxy that can be used to invoke remote methods on the exported remote object.
`boolean` | `unexport(boolean force)` Unexports the remote object that was exported by this `Exporter` such that it will no longer receive remote method invocations that were made possible as a result of exporting it with this `Exporter`.

Method Detail

### export

    public Remote export(Remote impl)
                  throws ExportException

  Exports the specified remote object and returns a proxy that can be used to invoke remote methods on the exported remote object. This method must only be invoked once on a given `Exporter` instance.

  The returned proxy implements an implementation-specific set of remote interfaces of the remote object and may also implement additional implementation-specific interfaces.

  A remote interface is an interface that extends the interface `java.rmi.Remote` and whose methods each declare at least one exception whose type is `java.rmi.RemoteException` or one of its superclasses.

  Parameters:
    `impl` - a remote object to export
  Returns:
    a proxy for the remote object
  Throws:
    `ExportException` - if a problem occurs exporting the object
    `SecurityException` - if a `SecurityException` occurs exporting the object
    `NullPointerException` - if `impl` is `null`
    `IllegalStateException` - if an object has already been exported with this `Exporter` instance

### unexport

    public boolean unexport(boolean force)

  Unexports the remote object that was exported by this `Exporter` such that it will no longer receive remote method invocations that were made possible as a result of exporting it with this `Exporter`. The unexport operation may not occur if the `force` argument is `false`. This method must only be invoked after the `export` method has been invoked on this `Exporter` instance to export a remote object successfully.

  This method returns `true` if upon return, the remote object is no longer exported with this `Exporter`, and `false` if the remote object remains exported with this `Exporter`. This method will always return `true` if it has returned `true` previously.

  The `force` parameter serves to indicate whether or not the caller desires the unexport to occur even if there are known remote calls pending or in progress to the remote object that were made possible by this `Exporter`:

  - If `force` is `true`, then the remote object will be forcibly unexported even if there are remote calls pending or in progress, and this method will return `true`.
  - If `force` is `false`, then this acts as a hint to the implementation that the remote object should not be unexported if there are known remote calls pending or in progress, and this method will either unexport the remote object and return `true` or not unexport the remote object and return `false`. If the implementation detects that there are indeed remote calls pending or in progress, then it should return `false`; otherwise, it must return `true`. If the implementation does not support being able to unexport conditionally based on knowledge of remote calls pending or in progress, then it must implement this method as if `force` were always `true`.

  If the remote object is unexported as a result of this method, then the implementation may (and should, if possible) prevent remote calls in progress from being able to communicate their results successfully.

  Parameters:
    `force` - if `true`, the remote object will be unexported even if there are remote calls pending or in progress; if `false`, the remote object may only be unexported if there are no known remote calls pending or in progress
  Returns:
    `true` if the remote object is unexported when this method returns and `false` otherwise
  Throws:
    `IllegalStateException` - if an object has not been exported with this `Exporter` instance

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 Sun Microsystems, Inc. All rights reserved